/****************************************************************
*																*
*		Loadable RuntimeSpaceeXtender Demo						*
*		2.4.x porting											*
*		by IhaQueR												*
*																*
****************************************************************/




#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/signal.h>



char *p1, *p2;

unsigned fun(void);
typedef unsigned (*VF)(void);


unsigned doit(char* buf)
{
unsigned (*fp)(void);
	
	memcpy(buf, (char*)(&fun), 128);	
	fp = (VF)buf;
	fflush(stdout);

return (*fp)();
}


unsigned fun(void)
{
	__asm__ ("movl $0xabcd, %eax");
}


void printcs()
{
unsigned mycs=0;

		__asm__("movl %cs, %eax");
		__asm__("movl %%eax, %0" : "=m" (mycs) );
		printf("\ncurrent CS is : 0x%.8x\n", mycs);
}


void jumpme(void (*trampoline)())
{
	(*trampoline)();
}


void do_trampoline()
{
	void trampoline()
	{
		printf(" trampoline succeded\n");
	}

	jumpme(&trampoline);
}


int cnt=0;

void sighand(int v)
{
	cnt++;
}


void do_sig()
{
struct sigaction sa;
sigset_t mask;
unsigned cs1, cs2;


		__asm__("movl %cs, %eax");
		__asm__("movl %%eax, %0" : "=m" (cs1) );

		sigemptyset(&mask);

		sa.sa_handler = &sighand;
		sa.sa_restorer = NULL;
		sa.sa_mask = mask;
		sa.sa_flags = SA_ONESHOT;

		sigaction(SIGUSR1, &sa, NULL);

		kill(getpid(), SIGUSR1);
		usleep(100000);

		__asm__("movl %cs, %eax");
		__asm__("movl %%eax, %0" : "=m" (cs2) );

		if(cnt==1 && cs1==cs2)
			printf("succeded 0x%x == 0x%x\n", cs1, cs2);
		else
			printf("failed %d  cs1: 0x%x  cs2: 0x%x\n", cnt, cs1, cs2);
}


int main(int ac, char** av)
{
unsigned c=0, j=0;
char buf[256];

	if(ac < 2) {
		printf("usage: %s <0=stack, 1=heap, 2=longheap, 3=trampoline, 4=signal>\n\n", av[0]);
		exit(2);
	}

	printf("\nstack buffer:\t%p", buf);
	p1=(char*)malloc(1024);
	printf("\nshort heap:\t%p", p1);
	p2=(char*)malloc(1024*1024);
	printf("\nlong heap:\t%p", p2);

	printcs();

	switch(atoi(av[1])) {
	case 0:
		printf("\nprepare for stack fault... ");
		fflush(stdout);
		printf(" RET = %x\n\n", doit(buf));
		printf("...oooops, I'M ALIVE!!!\n\n");
		fflush(stdout);
		break;

	case 1: 
		printf("\nprepare for heap fault... ");
		fflush(stdout);
		printf(" RET = %x\n\n", doit(p1));
		printf("...oooops, I'M ALIVE!!!\n\n");
		fflush(stdout);
		break;

	case 2: 
		printf("\nprepare for long heap fault... ");
		fflush(stdout);
		printf(" RET = %x\n\n", doit(p2));
		printf("...oooops, I'M ALIVE!!!\n\n");
		fflush(stdout);
		break;

	case 3:
		printf("\nchecking trampoline... ");
		fflush(stdout);
		do_trampoline();
		break;
	
	case 4:
		printf("\nchecking signal handling... ");
		fflush(stdout);
		do_sig();
		break;

	default:
		printf("\nhuh?!");
	}

	printf("\n");
	fflush(stdout);
}
