/****************************************************************
*																*
*		Loadable RuntimeSpaceeXtender							*
*		2.4.x porting											*
*		by IhaQueR												*
*																*
****************************************************************/




#include <rsx.h>

#define __NO_VERSION__



//		counts the chars without the trailing 0
int mystrlen(const char* str)
{
int len = 0;

		while(str[len])
			len++;

return len;
}


//		own strcpy, attention about userspace strings...
void mystrcpy(char *dst, char *src)
{
		while(*src) {
			*dst = *src;
			dst++;
			src++;
		}

		*dst=0;
}


//		own strcat :-)
void mystrcat(char *dst, char *src)
{
		while(*dst)
			dst++;

		while(*src) {
			*dst = *src;
			dst++;
			src++;
		}

		*dst=0;
}


//		like well known strcmp()
int mystrcmp(const char *str1, const char *str2)
{
		while(*str1 && *str2)
			if(*(str1++) != *(str2++))
				return(*(str1-1) - *(str2-1));

return(*(str1) - *(str2));
}


int mystrncmp(const char *str1, const char *str2, int num)
{
		while(*str1 && *str2 && num-->0)
			if(*(str1++) != *(str2++))
				return(*(str1-1) - *(str2-1));

return(*(str1) - *(str2));
}


//		is c in the delim set?
int is_token(char c, char* delim)
{
		while(*delim) {
			if(c == *delim)
				return TRUE;
			delim++;
		}

return FALSE;
}


//		returns the ptr to the next token marked by delimiters, all subsequent token chars are skipped
char* get_tok(char* ptr, char* delim)
{
		while(*ptr && !is_token(*ptr, delim))
			ptr++;
		while(*ptr && is_token(*ptr, delim))
			ptr++;

return ptr;
}


char* get_tok_num(char* ptr, char* delim, int num)
{
		while(num>0 && *ptr && !is_token(*ptr, delim)) {
			ptr++;
			num--;
		}

		while(num>0 && *ptr && is_token(*ptr, delim)) {
			ptr++;
			num--;
		}

		if(num<0)
			return NULL;

return ptr;
}
