/****************************************************************
*																*
*		Loadable RuntimeSpaceeXtender							*
*		2.4.x porting											*
*		by IhaQueR												*
*																*
****************************************************************/




#include <rsx.h>

#ifdef RSX_HAVEPROC
#define __NO_VERSION__



static char* ProcFileName = "rsx";


//	proc statistics
unsigned rsx_stat_exec = 0;
unsigned rsx_stat_execok = 0;
unsigned rsx_stat_execremap = 0;

unsigned rsx_stat_fork = 0;
unsigned rsx_stat_forkok = 0;
unsigned rsx_stat_forkremap = 0;

unsigned rsx_stat_mmap = 0;
unsigned rsx_stat_mmapok = 0;
unsigned rsx_stat_mmapremap = 0;

unsigned rsx_stat_mmap2 = 0;
unsigned rsx_stat_mmap2ok = 0;
unsigned rsx_stat_mmap2remap = 0;

unsigned rsx_stat_gp = 0;

unsigned rsx_stat_trampolines = 0;
unsigned rsx_stat_trampolinesok = 0;
unsigned rsx_stat_trampolinesbad = 0;

unsigned rsx_stat_vmacalls = 0;
unsigned rsx_stat_vmaremaps = 0;
unsigned rsx_stat_vmafixes = 0;

unsigned rsx_stat_kills = 0;




//		called during proc read
static int get_info(char *buf, char **bufoff, off_t offset, int count)
{
static char tmp[1024];
int cnt=0, num=0, ocount;


		ocount = count;
		tmp[1023]=0;
		tmp[0]=0;
		cnt = sprintf(tmp, "%s statistics\n\n", MODNAME);
		if(count-cnt < 0)
			goto out_cnt;
		else {
			count -= cnt;
			num += cnt;
		}
		mystrcpy(buf, tmp);
		buf += cnt;

//	execve statitics
		tmp[1023]=0;
		tmp[0]=0;
		cnt = sprintf(tmp, "execve:\t%.8d\t%.8d\t%.8d\t[cnt/ok/remap]\n", rsx_stat_exec, rsx_stat_execok, rsx_stat_execremap);
		if(count-cnt < 0)
			goto out_cnt;
		else {
			count -= cnt;
			num += cnt;
		}
		mystrcpy(buf, tmp);
		buf += cnt;

//	fork statistics
		tmp[1023]=0;
		tmp[0]=0;
		cnt = sprintf(tmp, "fork:\t%.8d\t%.8d\t%.8d\t[cnt/ok/remap]\n", rsx_stat_fork, rsx_stat_forkok, rsx_stat_forkremap);
		if(count-cnt < 0)
			goto out_cnt;
		else {
			count -= cnt;
			num += cnt;
		}
		mystrcpy(buf, tmp);
		buf += cnt;

//	mmap statistics
		tmp[1023]=0;
		tmp[0]=0;
		cnt = sprintf(tmp, "mmap:\t%.8d\t%.8d\t%.8d\t[cnt/ok/remap]\n", rsx_stat_mmap, rsx_stat_mmapok, rsx_stat_mmapremap);
		if(count-cnt < 0)
			goto out_cnt;
		else {
			count -= cnt;
			num += cnt;
		}
		mystrcpy(buf, tmp);
		buf += cnt;

//	mmap2 statistics
		tmp[1023]=0;
		tmp[0]=0;
		cnt = sprintf(tmp, "mmap2:\t%.8d\t%.8d\t%.8d\t[cnt/ok/remap]\n", rsx_stat_mmap2, rsx_stat_mmap2ok, rsx_stat_mmap2remap);
		if(count-cnt < 0)
			goto out_cnt;
		else {
			count -= cnt;
			num += cnt;
		}
		mystrcpy(buf, tmp);
		buf += cnt;

//	#gp stat
		tmp[1023]=0;
		tmp[0]=0;
		cnt = sprintf(tmp, "#gp:\t%.8d\t\t\t\t\t[cnt]\n", rsx_stat_gp);
		if(count-cnt < 0)
			goto out_cnt;
		else {
			count -= cnt;
			num += cnt;
		}
		mystrcpy(buf, tmp);
		buf += cnt;

#ifdef RSX_TRAMPOLINE
//	trampoline statistics
		tmp[1023]=0;
		tmp[0]=0;
		cnt = sprintf(tmp, "tramp:\t%.8d\t%.8d\t%.8d\t[cnt/ok/bad]\n", rsx_stat_trampolines, rsx_stat_trampolinesok, rsx_stat_trampolinesbad);
		if(count-cnt < 0)
			goto out_cnt;
		else {
			count -= cnt;
			num += cnt;
		}
		mystrcpy(buf, tmp);
		buf += cnt;
#endif

//	vma stat
		tmp[1023]=0;
		tmp[0]=0;
		cnt = sprintf(tmp, "vma:\t%.8d\t%.8d\t%.8d\t[calls/remaps/fixes]\n", rsx_stat_vmacalls, rsx_stat_vmaremaps, rsx_stat_vmafixes);
		if(count-cnt < 0)
			goto out_cnt;
		else {
			count -= cnt;
			num += cnt;
		}
		mystrcpy(buf, tmp);
		buf += cnt;

//	termination stat
		tmp[1023]=0;
		tmp[0]=0;
		cnt = sprintf(tmp, "kills:\t%.8d\t\t\t\t\t[cnt]\n", rsx_stat_kills);
		if(count-cnt < 0)
			goto out_cnt;
		else {
			count -= cnt;
			num += cnt;
		}
		mystrcpy(buf, tmp);
		buf += cnt;

out_cnt:
		*buf = 0;

return (ocount > num) ? num : ocount;
}


//		called during proc write
static ssize_t module_input(struct file *file, const char *buffer, unsigned long count, void *data)
{
char c;

		get_user(c, buffer);

		if(c=='1' && current->uid==0) {
			printk("%s: resetting /proc statistics!\n", MODNAME);

			rsx_stat_exec = 0;
			rsx_stat_execok = 0;
			rsx_stat_execremap = 0;

			rsx_stat_fork = 0;
			rsx_stat_forkok = 0;
			rsx_stat_forkremap = 0;

			rsx_stat_mmap = 0;
			rsx_stat_mmapok = 0;
			rsx_stat_mmapremap = 0;

			rsx_stat_mmap2 = 0;
			rsx_stat_mmap2ok = 0;
			rsx_stat_mmap2remap = 0;

			rsx_stat_gp = 0;

			rsx_stat_trampolines = 0;
			rsx_stat_trampolinesok = 0;
			rsx_stat_trampolinesbad = 0;

			rsx_stat_vmacalls = 0;
			rsx_stat_vmaremaps = 0;
			rsx_stat_vmafixes = 0;

			rsx_stat_kills = 0;
		}
		else
			_RDEB printk("%s: attempt to reset /proc statistics by uid=%d\n", MODNAME, current->uid);

return count;
}


//		check permissions
static int module_permission(struct inode *inode, int op)
{
		if (op == 4 || (op == 2 && current->euid == 0))
		    return 0; 

 return -EACCES;
}


static struct file_operations File_Ops = {
		NULL, NULL,
		NULL, NULL,
		NULL,
		NULL,
		NULL,
		NULL,
		NULL,
		NULL,
		NULL,
};

static struct inode_operations Inode_Ops = {
		NULL,
		NULL,
		NULL,
		NULL,
		NULL,
		NULL,
		NULL,
		NULL,
		NULL,
		NULL,
		NULL,
		NULL,
		module_permission
};


static struct proc_dir_entry Proc_File = {
		0, 
		0,
		NULL,
		S_IFREG | S_IRUGO | S_IWUSR, 
		1,
		0, 0,
	    64,
		&Inode_Ops,
		&File_Ops,
		get_info
}; 


//		initialize proc entry
int rsx_init_proc(void)
{
struct proc_dir_entry* pd;
 
		_RDEB printk("%s: registering /proc/%s\n", MODNAME, ProcFileName);

		Proc_File.namelen = mystrlen(ProcFileName);
		Proc_File.name = ProcFileName;

		pd = create_proc_entry(ProcFileName, S_IFREG | S_IRUGO | S_IWUSR, &proc_root);
		
		if(pd) {
			pd->get_info = &get_info;
			pd->write_proc = &module_input;
			pd->size = PAGE_SIZE;
		}

return pd != NULL;
}


//		cleanup proc entry
void rsx_cleanup_proc(void)
{
		_RDEB printk("%s: deregistering /proc/%s\n", MODNAME, ProcFileName);
		remove_proc_entry(ProcFileName, &proc_root);
}
#endif
